diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/utils.js /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/utils.js
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/utils.js	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/utils.js	2012-12-17 16:18:40.000000000 -0600
***************
*** 0 ****
--- 1,171 ----
+ // utility functions
+ 
+ var wpCookies = {
+ // The following functions are from Cookie.js class in TinyMCE, Moxiecode, used under LGPL.
+ 
+ 	each : function(obj, cb, scope) {
+ 		var n, l;
+ 
+ 		if ( !obj )
+ 			return 0;
+ 
+ 		scope = scope || obj;
+ 
+ 		if ( typeof(obj.length) != 'undefined' ) {
+ 			for ( n = 0, l = obj.length; n < l; n++ ) {
+ 				if ( cb.call(scope, obj[n], n, obj) === false )
+ 					return 0;
+ 			}
+ 		} else {
+ 			for ( n in obj ) {
+ 				if ( obj.hasOwnProperty(n) ) {
+ 					if ( cb.call(scope, obj[n], n, obj) === false ) {
+ 						return 0;
+ 					}
+ 				}
+ 			}
+ 		}
+ 		return 1;
+ 	},
+ 
+ 	/**
+ 	 * Get a multi-values cookie.
+ 	 * Returns a JS object with the name: 'value' pairs.
+ 	 */
+ 	getHash : function(name) {
+ 		var all = this.get(name), ret;
+ 
+ 		if ( all ) {
+ 			this.each( all.split('&'), function(pair) {
+ 				pair = pair.split('=');
+ 				ret = ret || {};
+ 				ret[pair[0]] = pair[1];
+ 			});
+ 		}
+ 		return ret;
+ 	},
+ 
+ 	/**
+ 	 * Set a multi-values cookie.
+ 	 *
+ 	 * 'values_obj' is the JS object that is stored. It is encoded as URI in wpCookies.set().
+ 	 */
+ 	setHash : function(name, values_obj, expires, path, domain, secure) {
+ 		var str = '';
+ 
+ 		this.each(values_obj, function(val, key) {
+ 			str += (!str ? '' : '&') + key + '=' + val;
+ 		});
+ 
+ 		this.set(name, str, expires, path, domain, secure);
+ 	},
+ 
+ 	/**
+ 	 * Get a cookie.
+ 	 */
+ 	get : function(name) {
+ 		var cookie = document.cookie, e, p = name + "=", b;
+ 
+ 		if ( !cookie )
+ 			return;
+ 
+ 		b = cookie.indexOf("; " + p);
+ 
+ 		if ( b == -1 ) {
+ 			b = cookie.indexOf(p);
+ 
+ 			if ( b != 0 )
+ 				return null;
+ 
+ 		} else {
+ 			b += 2;
+ 		}
+ 
+ 		e = cookie.indexOf(";", b);
+ 
+ 		if ( e == -1 )
+ 			e = cookie.length;
+ 
+ 		return decodeURIComponent( cookie.substring(b + p.length, e) );
+ 	},
+ 
+ 	/**
+ 	 * Set a cookie.
+ 	 *
+ 	 * The 'expires' arg can be either a JS Date() object set to the expiration date (back-compat)
+ 	 * or the number of seconds until expiration
+ 	 */
+ 	set : function(name, value, expires, path, domain, secure) {
+ 		var d = new Date();
+ 
+ 		if ( typeof(expires) == 'object' && expires.toGMTString ) {
+ 			expires = expires.toGMTString();
+ 		} else if ( parseInt(expires, 10) ) {
+ 			d.setTime( d.getTime() + ( parseInt(expires, 10) * 1000 ) ); // time must be in miliseconds
+ 			expires = d.toGMTString();
+ 		} else {
+ 			expires = '';
+ 		}
+ 
+ 		document.cookie = name + "=" + encodeURIComponent(value) +
+ 			((expires) ? "; expires=" + expires : "") +
+ 			((path) ? "; path=" + path : "") +
+ 			((domain) ? "; domain=" + domain : "") +
+ 			((secure) ? "; secure" : "");
+ 	},
+ 
+ 	/**
+ 	 * Remove a cookie.
+ 	 *
+ 	 * This is done by setting it to an empty value and setting the expiration time in the past.
+ 	 */
+ 	remove : function(name, path) {
+ 		this.set(name, '', -1000, path);
+ 	}
+ };
+ 
+ // Returns the value as string. Second arg or empty string is returned when value is not set.
+ function getUserSetting( name, def ) {
+ 	var obj = getAllUserSettings();
+ 
+ 	if ( obj.hasOwnProperty(name) )
+ 		return obj[name];
+ 
+ 	if ( typeof def != 'undefined' )
+ 		return def;
+ 
+ 	return '';
+ }
+ 
+ // Both name and value must be only ASCII letters, numbers or underscore
+ // and the shorter, the better (cookies can store maximum 4KB). Not suitable to store text.
+ function setUserSetting( name, value, _del ) {
+ 	if ( 'object' !== typeof userSettings )
+ 		return false;
+ 
+ 	var cookie = 'wp-settings-' + userSettings.uid, all = wpCookies.getHash(cookie) || {}, path = userSettings.url,
+ 	n = name.toString().replace(/[^A-Za-z0-9_]/, ''), v = value.toString().replace(/[^A-Za-z0-9_]/, '');
+ 
+ 	if ( _del ) {
+ 		delete all[n];
+ 	} else {
+ 		all[n] = v;
+ 	}
+ 
+ 	wpCookies.setHash(cookie, all, 31536000, path);
+ 	wpCookies.set('wp-settings-time-'+userSettings.uid, userSettings.time, 31536000, path);
+ 
+ 	return name;
+ }
+ 
+ function deleteUserSetting( name ) {
+ 	return setUserSetting( name, '', 1 );
+ }
+ 
+ // Returns all settings as js object.
+ function getAllUserSettings() {
+ 	if ( 'object' !== typeof userSettings )
+ 		return {};
+ 
+ 	return wpCookies.getHash('wp-settings-' + userSettings.uid) || {};
+ }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/wp-list-revisions.js /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/wp-list-revisions.js
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/wp-list-revisions.js	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/wp-list-revisions.js	2012-12-17 16:18:40.000000000 -0600
***************
*** 1 ****
! (function(a){var b=function(){var d=document.getElementById("post-revisions"),c=d?d.getElementsByTagName("input"):[];d.onclick=function(){var g,f=0,e;for(g=0;g<c.length;g++){f+=c[g].checked?1:0;e=c[g].getAttribute("name");if(!c[g].checked&&("left"==e&&1>f||"right"==e&&1<f&&(!c[g-1]||!c[g-1].checked))&&!(c[g+1]&&c[g+1].checked&&"right"==c[g+1].getAttribute("name"))){c[g].style.visibility="hidden"}else{if("left"==e||"right"==e){c[g].style.visibility="visible"}}}};d.onclick()};if(a&&a.addEventListener){a.addEventListener("load",b,false)}else{if(a&&a.attachEvent){a.attachEvent("onload",b)}}})(window);
\ No newline at end of file
--- 1,24 ----
! (function(w) {
! 	var init = function() {
! 		var pr = document.getElementById('post-revisions'),
! 		inputs = pr ? pr.getElementsByTagName('input') : [];
! 		pr.onclick = function() {
! 			var i, checkCount = 0, side;
! 			for ( i = 0; i < inputs.length; i++ ) {
! 				checkCount += inputs[i].checked ? 1 : 0;
! 				side = inputs[i].getAttribute('name');
! 				if ( ! inputs[i].checked &&
! 				( 'left' == side && 1 > checkCount || 'right' == side && 1 < checkCount && ( ! inputs[i-1] || ! inputs[i-1].checked ) ) &&
! 				! ( inputs[i+1] && inputs[i+1].checked && 'right' == inputs[i+1].getAttribute('name') ) )
! 					inputs[i].style.visibility = 'hidden';
! 				else if ( 'left' == side || 'right' == side )
! 					inputs[i].style.visibility = 'visible';
! 			}
! 		}
! 		pr.onclick();
! 	}
! 	if ( w && w.addEventListener )
! 		w.addEventListener('load', init, false);
! 	else if ( w && w.attachEvent )
! 		w.attachEvent('onload', init);
! })(window);
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/kses.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/kses.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/kses.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/kses.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 34,39 ****
--- 34,44 ----
  /**
   * You can override this in a plugin.
   *
+  * The wp_kses_allowed_html filter is more powerful and supplies context.
+  * CUSTOM_TAGS is not recommended and should be considered deprecated.
+  *
+  * @see wp_kses_allowed_html()
+  *
   * @since 1.2.0
   */
  if ( ! defined( 'CUSTOM_TAGS' ) )
***************
*** 51,100 ****
  	$allowedposttags = array(
  		'address' => array(),
  		'a' => array(
- 			'class' => true,
  			'href' => true,
- 			'id' => true,
- 			'title' => true,
  			'rel' => true,
  			'rev' => true,
  			'name' => true,
  			'target' => true,
  		),
! 		'abbr' => array(
! 			'class' => true,
! 			'title' => true,
! 		),
! 		'acronym' => array(
! 			'title' => true,
  		),
  		'article' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'aside' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'b' => array(),
  		'big' => array(),
  		'blockquote' => array(
- 			'id' => true,
  			'cite' => true,
- 			'class' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
! 		'br' => array (
! 			'class' => true,
! 		),
  		'button' => array(
  			'disabled' => true,
  			'name' => true,
--- 56,97 ----
  	$allowedposttags = array(
  		'address' => array(),
  		'a' => array(
  			'href' => true,
  			'rel' => true,
  			'rev' => true,
  			'name' => true,
  			'target' => true,
  		),
! 		'abbr' => array(),
! 		'acronym' => array(),
! 		'area' => array(
! 			'alt' => true,
! 			'coords' => true,
! 			'href' => true,
! 			'nohref' => true,
! 			'shape' => true,
! 			'target' => true,
  		),
  		'article' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'aside' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'b' => array(),
  		'big' => array(),
  		'blockquote' => array(
  			'cite' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
! 		'br' => array(),
  		'button' => array(
  			'disabled' => true,
  			'name' => true,
***************
*** 103,126 ****
  		),
  		'caption' => array(
  			'align' => true,
- 			'class' => true,
  		),
! 		'cite' => array (
! 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'title' => true,
- 		),
- 		'code' => array (
- 			'style' => true,
  		),
  		'col' => array(
  			'align' => true,
  			'char' => true,
  			'charoff' => true,
  			'span' => true,
  			'dir' => true,
- 			'style' => true,
  			'valign' => true,
  			'width' => true,
  		),
--- 100,117 ----
  		),
  		'caption' => array(
  			'align' => true,
  		),
! 		'cite' => array(
  			'dir' => true,
  			'lang' => true,
  		),
+ 		'code' => array(),
  		'col' => array(
  			'align' => true,
  			'char' => true,
  			'charoff' => true,
  			'span' => true,
  			'dir' => true,
  			'valign' => true,
  			'width' => true,
  		),
***************
*** 130,148 ****
  		'dd' => array(),
  		'details' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
  			'open' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'div' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'dl' => array(),
--- 121,135 ----
***************
*** 151,168 ****
  		'fieldset' => array(),
  		'figure' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'figcaption' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'font' => array(
--- 138,151 ----
***************
*** 172,181 ****
  		),
  		'footer' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'form' => array(
--- 155,162 ----
***************
*** 189,247 ****
  		),
  		'h1' => array(
  			'align' => true,
- 			'class' => true,
- 			'id'    => true,
- 			'style' => true,
  		),
! 		'h2' => array (
  			'align' => true,
- 			'class' => true,
- 			'id'    => true,
- 			'style' => true,
  		),
! 		'h3' => array (
  			'align' => true,
- 			'class' => true,
- 			'id'    => true,
- 			'style' => true,
  		),
! 		'h4' => array (
  			'align' => true,
- 			'class' => true,
- 			'id'    => true,
- 			'style' => true,
  		),
! 		'h5' => array (
  			'align' => true,
- 			'class' => true,
- 			'id'    => true,
- 			'style' => true,
  		),
! 		'h6' => array (
  			'align' => true,
- 			'class' => true,
- 			'id'    => true,
- 			'style' => true,
  		),
  		'header' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'hgroup' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
! 		'hr' => array (
  			'align' => true,
- 			'class' => true,
  			'noshade' => true,
  			'size' => true,
  			'width' => true,
--- 170,205 ----
  		),
  		'h1' => array(
  			'align' => true,
  		),
! 		'h2' => array(
  			'align' => true,
  		),
! 		'h3' => array(
  			'align' => true,
  		),
! 		'h4' => array(
  			'align' => true,
  		),
! 		'h5' => array(
  			'align' => true,
  		),
! 		'h6' => array(
  			'align' => true,
  		),
  		'header' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'hgroup' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
! 		'hr' => array(
  			'align' => true,
  			'noshade' => true,
  			'size' => true,
  			'width' => true,
***************
*** 251,263 ****
  			'alt' => true,
  			'align' => true,
  			'border' => true,
- 			'class' => true,
  			'height' => true,
  			'hspace' => true,
  			'longdesc' => true,
  			'vspace' => true,
  			'src' => true,
! 			'style' => true,
  			'width' => true,
  		),
  		'ins' => array(
--- 209,220 ----
  			'alt' => true,
  			'align' => true,
  			'border' => true,
  			'height' => true,
  			'hspace' => true,
  			'longdesc' => true,
  			'vspace' => true,
  			'src' => true,
! 			'usemap' => true,
  			'width' => true,
  		),
  		'ins' => array(
***************
*** 271,335 ****
  		'legend' => array(
  			'align' => true,
  		),
! 		'li' => array (
  			'align' => true,
- 			'class' => true,
  		),
! 		'menu' => array (
! 			'class' => true,
! 			'style' => true,
  			'type' => true,
  		),
  		'nav' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'p' => array(
- 			'class' => true,
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'pre' => array(
- 			'style' => true,
  			'width' => true,
  		),
  		'q' => array(
  			'cite' => true,
  		),
  		's' => array(),
! 		'span' => array (
! 			'class' => true,
  			'dir' => true,
  			'align' => true,
  			'lang' => true,
- 			'style' => true,
- 			'title' => true,
  			'xml:lang' => true,
  		),
  		'section' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'strike' => array(),
  		'strong' => array(),
  		'sub' => array(),
  		'summary' => array(
  			'align' => true,
- 			'class' => true,
  			'dir' => true,
  			'lang' => true,
- 			'style' => true,
  			'xml:lang' => true,
  		),
  		'sup' => array(),
--- 228,281 ----
  		'legend' => array(
  			'align' => true,
  		),
! 		'li' => array(
  			'align' => true,
  		),
! 		'map' => array(
! 			'name' => true,
! 		),
! 		'menu' => array(
  			'type' => true,
  		),
  		'nav' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'p' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'pre' => array(
  			'width' => true,
  		),
  		'q' => array(
  			'cite' => true,
  		),
  		's' => array(),
! 		'span' => array(
  			'dir' => true,
  			'align' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'section' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
+ 		'small' => array(),
  		'strike' => array(),
  		'strong' => array(),
  		'sub' => array(),
  		'summary' => array(
  			'align' => true,
  			'dir' => true,
  			'lang' => true,
  			'xml:lang' => true,
  		),
  		'sup' => array(),
***************
*** 339,349 ****
  			'border' => true,
  			'cellpadding' => true,
  			'cellspacing' => true,
- 			'class' => true,
  			'dir' => true,
- 			'id' => true,
  			'rules' => true,
- 			'style' => true,
  			'summary' => true,
  			'width' => true,
  		),
--- 285,292 ----
***************
*** 360,366 ****
  			'bgcolor' => true,
  			'char' => true,
  			'charoff' => true,
- 			'class' => true,
  			'colspan' => true,
  			'dir' => true,
  			'headers' => true,
--- 303,308 ----
***************
*** 368,374 ****
  			'nowrap' => true,
  			'rowspan' => true,
  			'scope' => true,
- 			'style' => true,
  			'valign' => true,
  			'width' => true,
  		),
--- 310,315 ----
***************
*** 382,388 ****
  		'tfoot' => array(
  			'align' => true,
  			'char' => true,
- 			'class' => true,
  			'charoff' => true,
  			'valign' => true,
  		),
--- 323,328 ----
***************
*** 393,399 ****
  			'bgcolor' => true,
  			'char' => true,
  			'charoff' => true,
- 			'class' => true,
  			'colspan' => true,
  			'headers' => true,
  			'height' => true,
--- 333,338 ----
***************
*** 407,413 ****
  			'align' => true,
  			'char' => true,
  			'charoff' => true,
- 			'class' => true,
  			'valign' => true,
  		),
  		'title' => array(),
--- 346,351 ----
***************
*** 416,436 ****
  			'bgcolor' => true,
  			'char' => true,
  			'charoff' => true,
- 			'class' => true,
- 			'style' => true,
  			'valign' => true,
  		),
  		'tt' => array(),
  		'u' => array(),
! 		'ul' => array (
! 			'class' => true,
! 			'style' => true,
  			'type' => true,
  		),
! 		'ol' => array (
! 			'class' => true,
  			'start' => true,
- 			'style' => true,
  			'type' => true,
  		),
  		'var' => array(),
--- 354,368 ----
  			'bgcolor' => true,
  			'char' => true,
  			'charoff' => true,
  			'valign' => true,
  		),
  		'tt' => array(),
  		'u' => array(),
! 		'ul' => array(
  			'type' => true,
  		),
! 		'ol' => array(
  			'start' => true,
  			'type' => true,
  		),
  		'var' => array(),
***************
*** 457,485 ****
  		'blockquote' => array(
  			'cite' => true,
  		),
- 		//	'br' => array(),
  		'cite' => array(),
  		'code' => array(),
  		'del' => array(
  			'datetime' => true,
  		),
! 		//	'dd' => array(),
! 		//	'dl' => array(),
! 		//	'dt' => array(),
! 		'em' => array (), 'i' => array (),
! 		//	'ins' => array('datetime' => array(), 'cite' => array()),
! 		//	'li' => array(),
! 		//	'ol' => array(),
! 		//	'p' => array(),
  		'q' => array(
  			'cite' => true,
  		),
  		'strike' => array(),
  		'strong' => array(),
- 		//	'sub' => array(),
- 		//	'sup' => array(),
- 		//	'u' => array(),
- 		//	'ul' => array(),
  	);
  
  	$allowedentitynames = array(
--- 389,406 ----
  		'blockquote' => array(
  			'cite' => true,
  		),
  		'cite' => array(),
  		'code' => array(),
  		'del' => array(
  			'datetime' => true,
  		),
! 		'em' => array(),
! 		'i' => array(),
  		'q' => array(
  			'cite' => true,
  		),
  		'strike' => array(),
  		'strong' => array(),
  	);
  
  	$allowedentitynames = array(
***************
*** 525,530 ****
--- 446,456 ----
  		'sdot',    'lceil',  'rceil',   'lfloor', 'rfloor', 'lang',
  		'rang',    'loz',    'spades',  'clubs',  'hearts', 'diams',
  	);
+ 
+ 	$allowedposttags = array_map( '_wp_add_global_attributes', $allowedposttags );
+ } else {
+ 	$allowedtags = wp_kses_array_lc( $allowedtags );
+ 	$allowedposttags = wp_kses_array_lc( $allowedposttags );
  }
  
  /**
***************
*** 547,561 ****
   * @param array $allowed_protocols Optional. Allowed protocol in links.
   * @return string Filtered content with only allowed HTML elements
   */
! function wp_kses($string, $allowed_html, $allowed_protocols = array ()) {
  	if ( empty( $allowed_protocols ) )
  		$allowed_protocols = wp_allowed_protocols();
  	$string = wp_kses_no_null($string);
  	$string = wp_kses_js_entities($string);
  	$string = wp_kses_normalize_entities($string);
! 	$allowed_html_fixed = wp_kses_array_lc($allowed_html);
! 	$string = wp_kses_hook($string, $allowed_html_fixed, $allowed_protocols); // WP changed the order of these funcs and added args to wp_kses_hook
! 	return wp_kses_split($string, $allowed_html_fixed, $allowed_protocols);
  }
  
  /**
--- 473,523 ----
   * @param array $allowed_protocols Optional. Allowed protocol in links.
   * @return string Filtered content with only allowed HTML elements
   */
! function wp_kses( $string, $allowed_html, $allowed_protocols = array() ) {
  	if ( empty( $allowed_protocols ) )
  		$allowed_protocols = wp_allowed_protocols();
  	$string = wp_kses_no_null($string);
  	$string = wp_kses_js_entities($string);
  	$string = wp_kses_normalize_entities($string);
! 	$string = wp_kses_hook($string, $allowed_html, $allowed_protocols); // WP changed the order of these funcs and added args to wp_kses_hook
! 	return wp_kses_split($string, $allowed_html, $allowed_protocols);
! }
! 
! /**
!  * Return a list of allowed tags and attributes for a given context.
!  *
!  * @since 3.5.0
!  *
!  * @param string $context The context for which to retrieve tags. Allowed values are
!  *  post | strip | data | entities or the name of a field filter such as pre_user_description.
!  * @return array List of allowed tags and their allowed attributes.
!  */
! function wp_kses_allowed_html( $context = '' ) {
! 	global $allowedposttags, $allowedtags, $allowedentitynames;
! 
! 	if ( is_array( $context ) )
! 		return apply_filters( 'wp_kses_allowed_html', $context, 'explicit' );
! 
! 	switch ( $context ) {
! 		case 'post':
! 			return apply_filters( 'wp_kses_allowed_html', $allowedposttags, $context );
! 			break;
! 		case 'user_description':
! 		case 'pre_user_description':
! 			$tags = $allowedtags;
! 			$tags['a']['rel'] = true;
! 			return apply_filters( 'wp_kses_allowed_html', $tags, $context );
! 			break;
! 		case 'strip':
! 			return apply_filters( 'wp_kses_allowed_html', array(), $context );
! 			break;
! 		case 'entities':
! 			return apply_filters( 'wp_kses_allowed_html', $allowedentitynames, $context);
! 			break;
! 		case 'data':
! 		default:
! 			return apply_filters( 'wp_kses_allowed_html', $allowedtags, $context );
! 	}
  }
  
  /**
***************
*** 571,577 ****
   * @param array $allowed_protocols Allowed protocol in links
   * @return string Filtered content through 'pre_kses' hook
   */
! function wp_kses_hook($string, $allowed_html, $allowed_protocols) {
  	$string = apply_filters('pre_kses', $string, $allowed_html, $allowed_protocols);
  	return $string;
  }
--- 533,539 ----
   * @param array $allowed_protocols Allowed protocol in links
   * @return string Filtered content through 'pre_kses' hook
   */
! function wp_kses_hook( $string, $allowed_html, $allowed_protocols ) {
  	$string = apply_filters('pre_kses', $string, $allowed_html, $allowed_protocols);
  	return $string;
  }
***************
*** 599,605 ****
   * @param array $allowed_protocols Allowed protocols to keep
   * @return string Content with fixed HTML tags
   */
! function wp_kses_split($string, $allowed_html, $allowed_protocols) {
  	global $pass_allowed_html, $pass_allowed_protocols;
  	$pass_allowed_html = $allowed_html;
  	$pass_allowed_protocols = $allowed_protocols;
--- 561,567 ----
   * @param array $allowed_protocols Allowed protocols to keep
   * @return string Content with fixed HTML tags
   */
! function wp_kses_split( $string, $allowed_html, $allowed_protocols ) {
  	global $pass_allowed_html, $pass_allowed_protocols;
  	$pass_allowed_html = $allowed_html;
  	$pass_allowed_protocols = $allowed_protocols;
***************
*** 667,672 ****
--- 629,637 ----
  	$elem = $matches[2];
  	$attrlist = $matches[3];
  
+ 	if ( ! is_array( $allowed_html ) )
+ 		$allowed_html = wp_kses_allowed_html( $allowed_html );
+ 
  	if ( ! isset($allowed_html[strtolower($elem)]) )
  		return '';
  	# They are using a not allowed HTML element
***************
*** 698,703 ****
--- 663,671 ----
  function wp_kses_attr($element, $attr, $allowed_html, $allowed_protocols) {
  	# Is there a closing XHTML slash at the end of the attributes?
  
+ 	if ( ! is_array( $allowed_html ) )
+ 		$allowed_html = wp_kses_allowed_html( $allowed_html );
+ 
  	$xhtml_slash = '';
  	if (preg_match('%\s*/\s*$%', $attr))
  		$xhtml_slash = ' /';
***************
*** 776,782 ****
   * @return array List of attributes after parsing
   */
  function wp_kses_hair($attr, $allowed_protocols) {
! 	$attrarr = array ();
  	$mode = 0;
  	$attrname = '';
  	$uris = array('xmlns', 'profile', 'href', 'src', 'cite', 'classid', 'codebase', 'data', 'usemap', 'longdesc', 'action');
--- 744,750 ----
   * @return array List of attributes after parsing
   */
  function wp_kses_hair($attr, $allowed_protocols) {
! 	$attrarr = array();
  	$mode = 0;
  	$attrname = '';
  	$uris = array('xmlns', 'profile', 'href', 'src', 'cite', 'classid', 'codebase', 'data', 'usemap', 'longdesc', 'action');
***************
*** 1285,1293 ****
   * @param string $data Content to filter, expected to be escaped with slashes
   * @return string Filtered content
   */
! function wp_filter_kses($data) {
! 	global $allowedtags;
! 	return addslashes( wp_kses(stripslashes( $data ), $allowedtags) );
  }
  
  /**
--- 1253,1260 ----
   * @param string $data Content to filter, expected to be escaped with slashes
   * @return string Filtered content
   */
! function wp_filter_kses( $data ) {
! 	return addslashes( wp_kses( stripslashes( $data ), current_filter() ) );
  }
  
  /**
***************
*** 1299,1307 ****
   * @param string $data Content to filter, expected to not be escaped
   * @return string Filtered content
   */
! function wp_kses_data($data) {
! 	global $allowedtags;
! 	return wp_kses( $data , $allowedtags );
  }
  
  /**
--- 1266,1273 ----
   * @param string $data Content to filter, expected to not be escaped
   * @return string Filtered content
   */
! function wp_kses_data( $data ) {
! 	return wp_kses( $data , current_filter() );
  }
  
  /**
***************
*** 1311,1324 ****
   * data from forms.
   *
   * @since 2.0.0
-  * @uses $allowedposttags
   *
   * @param string $data Post content to filter, expected to be escaped with slashes
   * @return string Filtered post content with allowed HTML tags and attributes intact.
   */
  function wp_filter_post_kses($data) {
! 	global $allowedposttags;
! 	return addslashes ( wp_kses(stripslashes( $data ), $allowedposttags) );
  }
  
  /**
--- 1277,1288 ----
   * data from forms.
   *
   * @since 2.0.0
   *
   * @param string $data Post content to filter, expected to be escaped with slashes
   * @return string Filtered post content with allowed HTML tags and attributes intact.
   */
  function wp_filter_post_kses($data) {
! 	return addslashes ( wp_kses( stripslashes( $data ), 'post' ) );
  }
  
  /**
***************
*** 1328,1341 ****
   * data from forms.
   *
   * @since 2.9.0
-  * @uses $allowedposttags
   *
   * @param string $data Post content to filter
   * @return string Filtered post content with allowed HTML tags and attributes intact.
   */
  function wp_kses_post($data) {
! 	global $allowedposttags;
! 	return wp_kses( $data , $allowedposttags );
  }
  
  /**
--- 1292,1303 ----
   * data from forms.
   *
   * @since 2.9.0
   *
   * @param string $data Post content to filter
   * @return string Filtered post content with allowed HTML tags and attributes intact.
   */
  function wp_kses_post($data) {
! 	return wp_kses( $data , 'post' );
  }
  
  /**
***************
*** 1346,1353 ****
   * @param string $data Content to strip all HTML from
   * @return string Filtered content without any HTML
   */
! function wp_filter_nohtml_kses($data) {
! 	return addslashes ( wp_kses(stripslashes( $data ), array()) );
  }
  
  /**
--- 1308,1315 ----
   * @param string $data Content to strip all HTML from
   * @return string Filtered content without any HTML
   */
! function wp_filter_nohtml_kses( $data ) {
! 	return addslashes ( wp_kses( stripslashes( $data ), 'strip' ) );
  }
  
  /**
***************
*** 1483,1485 ****
--- 1445,1473 ----
  
  	return $css;
  }
+ 
+ /**
+  * Helper function to add global attributes to a tag in the allowed html list.
+  *
+  * @since 3.5.0
+  * @access private
+  *
+  * @param array $value An array of attributes.
+  * @return array The array of attributes with global attributes added.
+  */
+ function _wp_add_global_attributes( $value ) {
+ 	$global_attributes = array(
+ 		'class' => true,
+ 		'id' => true,
+ 		'style' => true,
+ 		'title' => true,
+ 	);
+ 
+ 	if ( true === $value )
+ 		$value = array();
+ 
+ 	if ( is_array( $value ) )
+ 		return array_merge( $value, $global_attributes );
+ 
+ 	return $value;
+ }
